From 89a5843cbe2453ad632200bfbcd18b46f3471fd2 Mon Sep 17 00:00:00 2001
From: David Powell <djpowell@djpowell.net>
Date: Sat, 5 Jun 2010 16:11:07 +0100
Subject: [PATCH 1/6] read stdout and stderr simultanously from separate threads to prevent stderr filling the buffer and hanging the process

---
 src/clj/clojure/java/shell.clj |    9 ++++-----
 1 files changed, 4 insertions(+), 5 deletions(-)

diff --git a/src/clj/clojure/java/shell.clj b/src/clj/clojure/java/shell.clj
index 11d908a..0d350c3 100644
--- a/src/clj/clojure/java/shell.clj
+++ b/src/clj/clojure/java/shell.clj
@@ -100,11 +100,9 @@ collecting its stdout"}
                 stderr (.getErrorStream proc)]
       (let [[out err]
             (if (= (:out opts) :bytes)
-              (for [strm [stdout stderr]]
-                (into-array Byte/TYPE (map byte (stream-seq strm))))
-              (for [strm [stdout stderr]]
-                (apply str (map char (stream-seq 
-                                      (InputStreamReader. strm (:out opts)))))))
+              (pmap #(into-array Byte/TYPE (map byte (stream-seq %))) [stdout stderr])
+              (pmap #(apply str (map char (stream-seq 
+                                      (InputStreamReader. % (:out opts))))) [stdout stderr]))
             exit-code (.waitFor proc)]
         {:exit exit-code :out out :err err}))))
 
@@ -117,5 +115,6 @@ collecting its stdout"}
 (println (sh "echo" "x\u25bax"))
 (println (sh "echo" "x\u25bax" :out "ISO-8859-1")) ; reads 4 single-byte chars
 (println (sh "cat" "myimage.png" :out :bytes)) ; reads binary file into bytes[]
+(println (sh "cmd" "/c dir 1>&2"))
 
 )
-- 
1.6.5.1.1367.gcd48

